Index: less/multi.h
diff -u /dev/null less/multi.h:1.16
--- /dev/null	Wed Dec  6 22:29:44 2000
+++ less/multi.h	Tue Nov 21 09:01:27 2000
@@ -0,0 +1,235 @@
+/*
+ * Copyright (c) 1997-2000  Kazushi (Jam) Marukawa
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice in the documentation and/or other materials provided with
+ *    the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY
+ * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
+ * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
+ * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+ * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
+ * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
+ * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+
+/*
+ * Definition of values to specify the character set.
+ * And definitions some well known character sets and a types of set.
+ */
+typedef unsigned short CHARSET;
+
+/*
+ * The structure of CHARSET:
+ *
+ *   151413121110 9 8 7 6 5 4 3 2 1 0
+ *   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ *   |r|    IRR    |m|n|      F      |
+ *   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ *
+ * r: true if it is not first byte of multi bytes character.
+ * IRR: represented identification of revisions of registered character
+ *      sets (IRR) ranged from 00/01 to 03/15.  The 00/00 means no IRR.
+ *      The real IRR is ranged from 00/01 to 03/15, and coded from 04/00
+ *	to 07/14.
+ * m: true if it is one byte in bytes of multi bytes character.
+ * n: true if it is one of 96 or 96x96 graphic sets, otherwise it is one
+ *    of 94 or 94x94 graphic sets.
+ * F: represented final byte which choose one of graphi sets ranged from
+ *    00/00 to 04/14.  The real final byte is coded from 03/00 to 07/14.
+ */
+
+#define	REST_MASK		0x8000		/* r */
+#define CSISHEAD(cs)		(!((cs) & REST_MASK))
+#define CSISREST(cs)		((cs) & REST_MASK)
+
+#define IRR_MASK		0x7e00		/* IRR */
+#define IRR_SHIFT		9
+#define CS2IRR(cs)		(((cs) & IRR_MASK) >> IRR_SHIFT)
+#define IRR2CS(irr)		(((irr) << IRR_SHIFT) & IRR_MASK)
+
+#define CODE_MASK		0x003f		/* coded IRR in ISO 2022 */
+#define CODE_DIFF		0x0040
+#define IRR2CODE(irr)		((((irr) - 1) & CODE_MASK) + CODE_DIFF)
+#define CODE2IRR(code)		((((code) - CODE_DIFF) & CODE_MASK) + 1)
+
+#define TYPE_94_CHARSET		0x0000		/* m & n */
+#define TYPE_96_CHARSET		0x0080
+#define TYPE_94N_CHARSET	0x0100
+#define TYPE_96N_CHARSET	0x0180
+#define TYPE_MASK		0x0180
+#define CS2TYPE(cs)		((cs) & TYPE_MASK)
+#define TYPE2CS(type)		((type) & TYPE_MASK)
+
+#define FT_MASK			0x007f		/* F */
+#define FT_DIFF			0x0030
+#define CS2FT(cs)		(((cs) & FT_MASK) + FT_DIFF)
+#define FT2CS(ft)		(((ft) - FT_DIFF) & FT_MASK)
+
+/*
+ * Each character sets is represented by IRR, TYPE and FT.
+ */
+#define CHARSET_MASK		(IRR_MASK | TYPE_MASK | FT_MASK)
+#define CS2CHARSET(cs)		((cs) & CHARSET_MASK)
+
+/*
+ * There is a reserved empty set in every type of charset.  07/14.
+ * So we cannot use (CS2CHARSET(cs) == WRONGCS) to check it.
+ */
+#define CSISWRONG(cs)		(CS2FT(cs) == '~')
+
+/*
+ * List of representative character sets.
+ */
+#define ASCII			(TYPE_94_CHARSET | FT2CS('B'))
+#define WRONGCS			(TYPE_94_CHARSET | FT2CS('~'))
+#if ISO
+#define JISX0201KANA		(TYPE_94_CHARSET | FT2CS('I'))
+#define JISX0201ROMAN		(TYPE_94_CHARSET | FT2CS('J'))
+#define LATIN1			(TYPE_96_CHARSET | FT2CS('A'))
+#define LATIN2			(TYPE_96_CHARSET | FT2CS('B'))
+#define LATIN3			(TYPE_96_CHARSET | FT2CS('C'))
+#define LATIN4			(TYPE_96_CHARSET | FT2CS('D'))
+#define GREEK			(TYPE_96_CHARSET | FT2CS('F'))
+#define ARABIC			(TYPE_96_CHARSET | FT2CS('G'))
+#define HEBREW			(TYPE_96_CHARSET | FT2CS('H'))
+#define CYRILLIC		(TYPE_96_CHARSET | FT2CS('L'))
+#define LATIN5			(TYPE_96_CHARSET | FT2CS('M'))
+#define JISX0208_78KANJI	(TYPE_94N_CHARSET | FT2CS('@'))
+#define GB2312			(TYPE_94N_CHARSET | FT2CS('A'))
+#define JISX0208KANJI		(TYPE_94N_CHARSET | FT2CS('B'))
+#define JISX0208_90KANJI	(IRR2CS(1) | TYPE_94N_CHARSET | FT2CS('B'))
+#define KSC5601			(TYPE_94N_CHARSET | FT2CS('C'))
+#define JISX0212KANJISUP	(TYPE_94N_CHARSET | FT2CS('D'))
+#define JISX0213KANJI1		(TYPE_94N_CHARSET | FT2CS('O'))
+#define JISX0213KANJI2		(TYPE_94N_CHARSET | FT2CS('P'))
+#if JAPANESE
+/*
+ * Special number for Japanese code set.  Only input_set use following with
+ * above definitions.  The 07/15 is not valid for F.  Thus I use it to
+ * indicate the special character sets.
+ */
+#define SJIS			(IRR2CS(1) | TYPE_94N_CHARSET | FT_MASK)
+#define UJIS			(IRR2CS(2) | TYPE_94N_CHARSET | FT_MASK)
+#endif
+#endif
+
+/*
+ * List of special characters and character set for it.
+ *
+ *	A terminator of string with character set is represented by
+ *    both a NULCH and a NULLCS.  A padding character in string with
+ *    character set is represented by both a PADCH and a NULLCS.  A
+ *    binary data '\0' and '\1' are represented by both '\0' and a
+ *    WRONGCS, and both '\1' and a WRONGCS respectively.
+ */
+#define NULCH			('\0')
+#define PADCH			('\1')
+#define NULLCS			(ASCII)
+
+/*
+ * Macros for easy checking.
+ */
+#define CSISASCII(cs)		(CS2CHARSET(cs) == ASCII)
+#define CSISNULLCS(cs)		(CS2CHARSET(cs) == NULLCS)
+
+
+/*
+ * Definition of values to specify the character set and character.
+ */
+typedef int CHARVAL;
+
+#define MAKECV(ch, cs)		(((cs) << 8 * sizeof(char)) | ch)
+#define CV2CH(cv)		((cv) & ((1 << 8 * sizeof(char)) - 1))
+#define CV2CS(cv)		((cv) >> 8 * sizeof(char))
+
+
+/*
+ * Definition of code sets.  The code set is not character set.
+ * It is only means of code, and we use these value when we
+ * decide what input data are.
+ */
+typedef enum {
+	/* code sets for left, right and output plane */
+	noconv,		/* A code set which doesn't need converting */
+	/* code sets for left and output plane */
+	jis,		/* A subset of ISO 2022 */
+		/*
+		 * It may contain JIS C 6226-1978, JIS X 0208-1983, 
+		 * JIS X 0208:1990/1997, JIS X 0212:1990, JIS X 0213:2000,
+		 * JIS X 0201:1976/1997 left/right planes, and ASCII as input.
+		 *
+		 * In the case of output, this means all JIS C 6226-1978,
+		 * JIS X 0208-1983, JIS X 0208:1990/1997, and JIS X 0213:2000
+		 * are converted into JIS X 0208-1983 encode with an assumption
+		 * that character set of JIS X 0208-1983 encode is
+		 * JIS X 0213:2000.  And JIS X 0212:1990 and 2nd plane of
+		 * JIS X 0213:2000 are rejected when output.
+		 *
+		 * If you need the same code as the output, please use iso7
+		 * or iso8.
+		 */
+	iso7,		/* A code set which is extented by iso2022 */
+	/* code sets for only right plane */
+	none,		/* No code set */
+	japanese,	/* Both of UJIS and SJIS */
+	/* code sets for right and output plane */
+	ujis,		/* Japanese code set named UJIS */
+	sjis,		/* Japanese code set named SJIS */
+	iso8		/* A code set which is extented by iso2022 */
+} CODESET;
+
+
+/*
+ * struct multibuf is internal data structure for multi.c.
+ * Defines it name only.
+ */
+typedef struct multibuf MULBUF;
+
+
+/*
+ * in multi.c
+ */
+extern int set_planeset ();
+extern void init_def_codesets ();
+extern void init_def_priority ();
+extern void init_priority ();
+extern CODESET get_priority ();
+extern void set_priority ();
+extern MULBUF * new_multi ();
+extern void clear_multi ();
+extern void init_multi ();
+extern void buffering_multi ();
+extern void parsing_multi ();
+extern void set_codesets ();
+extern int get_bufbytes ();
+extern void set_bufbytes ();
+extern char * get_icharset_string ();
+extern char * outchar();
+extern char * outbuf();
+extern int mwidth();
+extern char * rotate_right_codeset ();
+extern int strlen_cs();
+extern int chlen_cs();
+extern char* strdup_cs();
+
+/*
+ * in unify.c
+ */
+extern void jis78to90();
+extern void chconvert_cs();
+extern void chunify_cs();
+extern int chcmp_cs();
+extern int chisvalid_cs();
Index: less/optfunc.c
diff -u less/optfunc.c:1.1.1.15 less/optfunc.c:1.25
--- less/optfunc.c:1.1.1.15	Sun Oct 29 02:03:33 2000
+++ less/optfunc.c	Fri Nov 24 14:43:38 2000
@@ -7,6 +7,12 @@
  * For more information about less, or for information on how to 
  * contact the author, see the README file.
  */
+/*
+ * Copyright (c) 1997-2000  Kazushi (Jam) Marukawa
+ * All rights of japanized routines are reserved.
+ *
+ * You may distribute under the terms of the Less License.
+ */
 
 
 /*
@@ -61,6 +67,10 @@
 extern int so_fg_color, so_bg_color;
 extern int bl_fg_color, bl_bg_color;
 #endif
+#if JAPANESE
+extern char *opt_charset;
+extern int opt_Z_var;
+#endif
 
 
 #if LOGFILE
@@ -346,6 +356,66 @@
 	}
 }
 
+#if JAPANESE
+/*
+ * Handlers for -K option.
+ */
+	public void
+opt_K(type, s)
+	int type;
+	char *s;
+{
+	switch (type)
+	{
+	case INIT:
+		opt_charset = s;
+		init_charset();
+		break;
+	}
+}
+
+/*
+ * Handler for the -Z option.
+ */
+	/*ARGSUSED*/
+	public void
+opt_Z(type, s)
+	int type;
+	char *s;
+{
+	switch (type)
+	{
+	case INIT:
+		if (opt_Z_var == OPT_ON)
+			init_def_priority(sjis);
+		else if (opt_Z_var == OPT_OFF)
+			init_def_priority(ujis);
+		break;
+	case QUERY:
+		break;
+	case TOGGLE:
+		switch (get_priority(get_mulbuf(curr_ifile))) {
+		case sjis:
+			opt_Z_var = OPT_OFF;
+			break;
+		case ujis:
+			opt_Z_var = OPT_ON;
+			break;
+		case noconv:
+		default:
+			opt_Z_var = OPT_ONPLUS;	/* we use this to mean error */
+			return;
+		}
+		if (opt_Z_var == OPT_ON)
+			init_def_priority(sjis);
+		else if (opt_Z_var == OPT_OFF)
+			init_def_priority(ujis);
+		init_priority(get_mulbuf(curr_ifile));
+		break;
+	}
+}
+#endif
+
 /*
  * Handler for the -V option.
  */
@@ -372,6 +442,8 @@
 		putstr("less comes with NO WARRANTY, to the extent permitted by law.\n");
 		putstr("For information about the terms of redistribution,\n");
 		putstr("see the file named README in the less distribution.\n");
+		putstr("\nJapanized part of Less\n");
+	     	putstr("Copyright (c) 1994-2000  Kazushi (Jam) Marukawa\n");
 		quit(QUIT_OK);
 		break;
 	}
Index: less/option.c
diff -u less/option.c:1.1.1.10 less/option.c:1.18
--- less/option.c:1.1.1.10	Sun Oct 29 02:03:33 2000
+++ less/option.c	Tue Oct 31 04:30:40 2000
@@ -7,6 +7,12 @@
  * For more information about less, or for information on how to 
  * contact the author, see the README file.
  */
+/*
+ * Copyright (c) 1997-2000  Kazushi (Jam) Marukawa
+ * All rights of japanized routines are reserved.
+ *
+ * You may distribute under the terms of the Less License.
+ */
 
 
 /*
@@ -467,7 +473,7 @@
 {
 	static char buf[8];
 
-	sprintf(buf, "-%s", prchar(c));
+	sprintf(buf, "-%s", prchar(c, ASCII));
 	return (buf);
 }
 
Index: less/opttbl.c
diff -u less/opttbl.c:1.1.1.15 less/opttbl.c:1.27
--- less/opttbl.c:1.1.1.15	Sun Oct 29 02:19:11 2000
+++ less/opttbl.c	Tue Oct 31 04:30:40 2000
@@ -7,6 +7,12 @@
  * For more information about less, or for information on how to 
  * contact the author, see the README file.
  */
+/*
+ * Copyright (c) 1997-2000  Kazushi (Jam) Marukawa
+ * All rights of japanized routines are reserved.
+ *
+ * You may distribute under the terms of the Less License.
+ */
 
 
 /*
@@ -49,6 +55,10 @@
 #if HILITE_SEARCH
 public int hilite_search;	/* Highlight matched search patterns? */
 #endif
+#if JAPANESE
+public int opt_Z_var;		/* Initial variable for opt_Z */
+extern int markwrongchar;	/* Display marker instead of wrong character */
+#endif
 
 /*
  * Long option names.
@@ -98,6 +108,11 @@
 static struct optname X__optname     = { "no-init",              NULL };
 static struct optname y_optname      = { "max-forw-scroll",      NULL };
 static struct optname z_optname      = { "window",               NULL };
+#if JAPANESE
+static struct optname K_optname      = { "charset",              NULL };
+static struct optname W_optname      = { "mark-wrong-char",      NULL };
+static struct optname Z_optname      = { "change-priority",      NULL };
+#endif
 static struct optname quote_optname  = { "quotes",               NULL };
 static struct optname tilde_optname  = { "tilde",                NULL };
 static struct optname query_optname  = { "help",                 NULL };
@@ -202,6 +217,12 @@
 		NULL, NULL, NULL
 	},
 #endif
+#if JAPANESE
+	{ 'K', &K_optname,
+		STRING|NO_TOGGLE|NO_QUERY, 0, NULL, opt_K,
+		NULL, NULL, NULL
+	},
+#endif
 	{ 'l', NULL,
 		STRING|NO_TOGGLE|NO_QUERY, 0, NULL, opt_l,
 		NULL, NULL, NULL
@@ -286,6 +307,14 @@
 		"Highlight first unread line after forward-screen",
 		"Highlight first unread line after any forward movement",
 	},
+#if JAPANESE
+	{ 'W', &W_optname,
+		BOOL|REPAINT, OPT_OFF, &markwrongchar, NULL,
+		"Display marker instead of wrong character",
+		"Display wrong character",
+		NULL
+	},
+#endif
 	{ 'x', &x_optname,
 		NUMBER|REPAINT, 8, &tabstop, NULL,
 		"Tab stops: ",
@@ -310,6 +339,19 @@
 		"Scroll window size is %d lines",
 		NULL
 	},
+#if JAPANESE
+#ifdef SJIS_PRE
+#define OPT_Z OPT_ON
+#else
+#define OPT_Z OPT_OFF
+#endif
+	{ 'Z', &Z_optname,
+		BOOL|REPAINT, OPT_Z, &opt_Z_var, opt_Z,
+		"Give priority to the UJIS over the SJIS",
+		"Give priority to the SJIS over the UJIS",
+		"Cannot give priority since Japanese is not treated now",
+	},
+#endif
 	{ '"', &quote_optname,
 		STRING, 0, NULL, opt_quote,
 		"quotes: ", NULL, NULL
@@ -350,6 +392,12 @@
 		if (o->ovar != NULL)
 			*(o->ovar) = o->odefault;
 	}
+#if JAPANESE
+	if (opt_Z_var == OPT_ON)
+		init_def_priority(sjis);
+	else if (opt_Z_var == OPT_OFF)
+		init_def_priority(ujis);
+#endif
 }
 
 /*
Index: less/output.c
diff -u less/output.c:1.1.1.13 less/output.c:1.32
--- less/output.c:1.1.1.13	Sun Oct 29 02:03:33 2000
+++ less/output.c	Tue Oct 31 04:30:40 2000
@@ -7,6 +7,12 @@
  * For more information about less, or for information on how to 
  * contact the author, see the README file.
  */
+/*
+ * Copyright (c) 1997-2000  Kazushi (Jam) Marukawa
+ * All rights of japanized routines are reserved.
+ *
+ * You may distribute under the terms of the Less License.
+ */
 
 
 /*
@@ -38,6 +44,7 @@
 	register int c;
 	register int i;
 	int a;
+	int cs;
 	int curr_attr;
 
 	if (ABORT_SIGS())
@@ -51,7 +58,7 @@
 
 	curr_attr = AT_NORMAL;
 
-	for (i = 0;  (c = gline(i, &a)) != '\0';  i++)
+	for (i = 0;  (c = gline(i, &cs, &a)) != '\0';  i++)
 	{
 		if (a != curr_attr)
 		{
@@ -81,7 +88,11 @@
 		if (c == '\b')
 			putbs();
 		else
+#if ISO
+			putmchr(c, cs);
+#else
 			putchr(c);
+#endif
 	}
 
 	switch (curr_attr)
@@ -221,7 +232,7 @@
  * Output a character.
  */
 	public int
-putchr(c)
+putchr_raw(c)
 	int c;
 {
 	if (need_clr)
@@ -233,12 +244,12 @@
 	if (c == '\n' && is_tty)
 	{
 		/* remove_top(1); */
-		putchr('\r');
+		putchr_raw('\r');
 	}
 #else
 #ifdef _OSK
 	if (c == '\n' && is_tty)  /* In OS-9, '\n' == 0x0D */
-		putchr(0x0A);
+		putchr_raw(0x0A);
 #endif
 #endif
 	/*
@@ -255,11 +266,85 @@
  * Output a string.
  */
 	public void
-putstr(s)
+putstr_raw(s)
 	register char *s;
 {
+	while (*s != '\0')
+		putchr_raw(*s++);
+}
+
+/*
+ * Output a character as ASCII.
+ */
+	public int
+putchr(c)
+	int c;
+{
+#if ISO
+	char *p = outchar(c & 0377, ASCII);
+	putstr_raw(p);
+	return (c);
+#else
+	return (putchr_raw(c));
+#endif
+}
+
+/*
+ * Output a string as ASCII.
+ */
+	public void
+putstr(s)
+	char *s;
+{
+#if ISO
+	char *p = outbuf(s, ASCII);
+	putstr_raw(p);
+#else
+	putstr_raw(s);
+#endif
+}
+
+/*
+ * Output a character which is a part of multi-bytes character.
+ */
+	public int
+putmchr(c, cs)
+	int c;
+	CHARSET cs;
+{
+#if ISO
+	char *p = outchar(c & 0377, cs);
+	putstr_raw(p);
+#else
+	putchr_raw(c);
+#endif
+	return (c);
+}
+
+/*
+ * Output a part of multi-bytes character.
+ */
+	public int
+putmchrs(s, cs)
+	char *s;
+	CHARSET cs;
+{
+	int c = *s;
+	while (*s != '\0')
+		putmchr(*s++, cs);
+	return (c);
+}
+
+/*
+ * Output a string of multi-bytes character.
+ */
+	public void
+putmstr(s, cs)
+	char *s;
+	CHARSET *cs;
+{
 	while (*s != '\0')
-		putchr(*s++);
+		putmchr(*s++, *cs++);
 }
 
 
Index: less/prompt.c
diff -u less/prompt.c:1.1.1.11 less/prompt.c:1.20
--- less/prompt.c:1.1.1.11	Sun Oct 29 02:03:33 2000
+++ less/prompt.c	Tue Oct 31 04:30:40 2000
@@ -7,6 +7,12 @@
  * For more information about less, or for information on how to 
  * contact the author, see the README file.
  */
+/*
+ * Copyright (c) 1997-2000  Kazushi (Jam) Marukawa
+ * All rights of japanized routines are reserved.
+ *
+ * You may distribute under the terms of the Less License.
+ */
 
 
 /*
@@ -47,7 +53,7 @@
 static constant char M_proto[] =
   "?f%f .?n?m(file %i of %m) ..?ltlines %lt-%lb?L/%L. :byte %bB?s/%s. .?e(END) ?x- Next\\: %x.:?pB%pB\\%..%t";
 static constant char e_proto[] =
-  "?f%f .?m(file %i of %m) .?ltlines %lt-%lb?L/%L. .byte %bB?s/%s. ?e(END) :?pB%pB\\%..%t";
+  "?f%f .?m(file %i of %m) .?ltlines %lt-%lb?L/%L. .byte %bB?s/%s. ?e(END) :?pB%pB\\%.. code %K%t";
 static constant char h_proto[] =
   "HELP -- ?eEND -- Press g to see it again:Press RETURN for more., or q when done";
 
@@ -330,6 +336,13 @@
 			free(s);
 		} else
 			ap_quest();
+		break;
+	case 'K':	/* Character set or code set of last non ASCII char. */
+#if ISO
+		ap_str(get_icharset_string(get_mulbuf(curr_ifile)));
+#else
+		ap_str("");
+#endif
 		break;
 	}
 }
